#include <stdio.h>

struct node
  {
    char *info;
    struct node *next;
  };

void savelist(struct node *lp, FILE *fp)
  {
    for ( ; lp; lp = lp ->next)
       fwrite(lp->info, strlen(lp->info)+1, 1, fp);
  }

struct node *mklist(FILE *fp)
  {
    struct node *head = NULL, *lp, *np;
    fpos_t pos;
    int len;

    for (fgetpos(fp, &pos); getc(fp) != EOF;
         fgetpos(fp, &pos))
      {
        /* determine the length of the data string */
        for (len = 1; getc(fp); len++)
            ;

        /* reset the file position indicator to the beginning
           of the string */
        fsetpos(fp, &pos);

        /* create new node */
        np = (struct node *)malloc(sizeof(struct node));
        np->info = (char *)malloc(len);
        fread(np->info, sizeof(char), len, fp);
        np->next = NULL;

        /* link it */
        if (!head)
            head = lp = np;
        else
          {
            lp->next = np;
            lp = np;
          }
      }
    return head;
  }
