#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

char *strmcat(int narg, ... )
  {
    va_list argp;
    register int i, size;
    register char *str;

    /* determine the size of the concatenated string */
    va_start(argp, narg);
    for (size = i = 0; i < narg; i++)
        size += strlen(va_arg(argp, char *));
    va_end(argp);

    /* allocate memory for creating the concatenated string */
    str = (char *) calloc(size+1, sizeof(char));
    if (!str)
      {
        fprintf(stderr, "not enough memory\n");
        return NULL;
      }

    /* create the concatenated string */
    va_start(argp, narg);
    for (i = 0; i < narg; i++)
        strcat(str, va_arg(argp, char *));
    va_end(argp);

    return str;
  }
