#include <stdio.h>
#define  BONUS    0.0975
#define  REGULAR  0.0875

int main(void)
  {
    float   principal, rate, interest;
    int     years;

    /* prompt the user to provide input values */
    printf("principal and years of investment? ");

    /* read the input values */
    scanf("%f %d", &principal, &years);

    /* validate input */
    if (principal < 0 || years < 0)
      {
        printf("negative values in input\n");
        return 1;
      }

    /* determine the interest rate */
    rate = principal >= 10000 || years > 5 ?
               BONUS : REGULAR;

    /* compute interest */
    interest = principal * rate * years;

    /* print interest */
    printf("interest = %f\n", interest);

    /* successful completion */
    return 0;
  }
