/*
 *  count of characters, words, and lines in input
 */

#include <stdio.h>
#define  UP            1
#define  DOWN          0

int main(void)
  {
     int c, characters, words, lines, word_flag;
   
     characters = words = lines = 0;
     word_flag = DOWN;

     while ((c = getchar()) != EOF)
       {
         characters++;

         switch (c)
           {
             case '\n':
                 lines++;
             case '\t':
             case ' ':
                 word_flag = DOWN;
                 break;
             default:
                 if (word_flag == DOWN)
                   {
                     words++;
                     word_flag = UP;
                   }
           }
       }

    printf("%d %d %d\n", characters, words, lines);

    return 0;
  }
