#include <math.h>
#include <stdio.h>
#define  PI          3.1415927

void polar(float x, float y,
           float *pr,  float *ptheta);

int main(void)
  {
    float  x, y;
    float  r, theta;
 
    scanf("%f %f", &x, &y);

    /* provide addresses of r and theta to polar */
    polar(x, y, &r, &theta);

    printf("%f %f\n", r, theta);
    return 0;
  }

void polar(float x, float y,
           float *pr,  float *ptheta)
  {
    if (x == 0 && y == 0)  /* origin */
        *pr = *ptheta = 0;
    else
      {
        *pr = sqrt(x*x + y*y);
        *ptheta = atan2(y,x);
      }
  }
